#!/bin/bash
# script copyright 2006 Gene Heskett, License=GPLv2
# This script has two names as there is a softlink to it called "flush.sh"
# if it doesn't exist, please do an 
# ln -s backup.sh flush.sh
# This is the script that you run from your user amanda's crontab
# Either as backup.sh, or as flush.sh but that will usually be a hand operation.
# note, this must be run as the backup user, root=illegal
# PATH=/usr/local/sbin:/amanda/config-bak:/bin
# export PATH
# a shell wrapper for amdump
# echo $0
MYDIR="/GenesAmandaHelper-0.5"
# set this to zero for testing
DUMMY=1

# an error tally
PERFORM=0

# change to suit your setup
CONFIGNAME="Daily"

#echo dummy=$DUMMY

# change to suit your setup
CONFPATH=/usr/local/etc/amanda/Daily
#echo confpath=$CONFPATH 
#echo CONFIGNAME=$CONFIGNAME

TAPELIST=$CONFPATH/tapelist

#show the operator some variables
#echo This is $0 tapelist=$TAPELIST
#echo
#echo but first put the tapelist in order with a run of amcheck
/usr/local/sbin/amcheck $CONFIGNAME
#echo back in $0 - and the list should be sane

# chg-disk-slot now points at the tape amdump will try to use.
if [ -f $TAPELIST ] ; then
        read TAPEDATE TAPENAME TAPESTATUS junk < $TAPELIST
	TAPENUM=${TAPENAME##*-}
#        echo $0 $TAPENAME
#	echo $0 $TAPENUM
fi
# Ok, so we have a bogus TAPENUM, so how about we really read it from
# chg-disk-slot, eh! 
# Note, for vtapes ONLY, not real tapes
read TAPENUM < $CONFPATH/chg-disk-slot

# now echo the invocation name and tapenum
#echo $0 tapenum is now=$TAPENUM

# echo now trying to read runtapes from $CONFPATH/amanda.conf
STRI=""
RUNTAPES=""
while [[ $STRI != "runtapes" ]] ; do
	read STRI FIRSTVAR junk
	if [[ $STRI == "tapecycle" ]] ; then
		TAPECYCLE=$FIRSTVAR
#		echo $0 tapecycle=$TAPECYCLE
	fi
done < $CONFPATH/amanda.conf
RUNTAPES=$FIRSTVAR

# if I ever go back to runtapes > 1, get tapecycle too!  Use the same method.
# Or, modify this one since runtapes is below tapecycle, it would go by
#echo $0 runtapes=$RUNTAPES

# enable this for tape
#echo amanda's chg-scsi cannot rewind tape so we are using mt
#/bin/mt -f /dev/nst0 rewind

# now, if just testing the script, get out
if [[ $DUMMY == "0" ]]; then
	echo exiting from dummy check
	exit 0;
fi

# now, are we running as backup.sh?
if [ $0 == "./backup.sh" ]||[ $0 == $MYDIR"/backup.sh" ]||[ $0 == "backup.sh" ]; then
#	echo running /usr/local/sbin/amdump Daily
	/usr/local/sbin/amdump Daily
	# give the drive time to flush its buffers
#	echo $0 dump finished.
	sleep 15;
	# then append the indices and configs
#	echo now running bak-indices-configs
	$MYDIR/bak-indices-configs;
	PERFORM=1 
#	echo bak-indices-configs is done and returned to $0
fi

# or are we running as flush.sh
if [ $0 == "./flush.sh" ]|| [ $0 == $MYDIR"/flush.sh" ]||[ $0 == "flush.sh" ]; then
	# we don't want amflush to disconnect or ask questions
#	echo backup script running amflush -bf;
	# below rewquired for real tapes if using chg-scsi
	# echo amanda cannot rewind, so mt to the rescue
	# /bin/mt -f /dev/nst0 rewind;
	# let the drive settle after the rewind
	sleep 15;
	/usr/local/sbin/amflush -bf Daily;
	# give the drive time to flush its buffers
	sleep 20;
#	echo flush done, appending index and config
	# append the indices and configs even to a short tape
	$MYDIR/flush-indices-configs;
#	echo flush-indices-configs is done and returned to $0
	PERFORM=1
fi

# sleep for disk sync
sleep 10

# now, were we successfull?
if [ $PERFORM == 0 ]; then
	echo something went wrong, the backup or flush was not done
	exit 1
fi

# Now, this is why we saved $TAPENUM and $RUNTAPES
# And please note that you will get 2 emails from this piece,
# one from this script while amverify is running, and another,
# seperate one from amverify itself, and I don't know how to
# fix that.
# The calling syntax for amverify is:
# amverify configname [[starting-slot] [num-slots]]
#echo Now we run amverify starting it on the first tape used
#echo Now running amverify $CONFIGNAME $TAPENUM $RUNTAPES
/usr/local/sbin/amverify $CONFIGNAME $TAPENUM $RUNTAPES
#echo $0 is done, exiting
exit 0

